
package com.molino.ai;

import com.molino.cache.LRUCache;

/**
 * Implementacion de la tabla de transposicion usando el menos recientemente usado con un tamao  maximo de 30000 nodos.
 */
public class LRUTranspositionTable<S extends Comparable> implements TranspositionTable<S>
{
    /**
	 * @uml.property  name="cache"
	 * @uml.associationEnd  
	 */
    private LRUCache<SearchNode<S>, SearchNode<S>> cache;

    public LRUTranspositionTable()
    {
        reset();
    }

    public void reset()
    {
        cache = new LRUCache(30000);
    }

    public void put(SearchNode<S> node)
    {
        if ( cache.get(node)==null )
            cache.put(node, node);
    }

    public SearchNode<S> get(SearchNode<S> node)
    {
        return cache.get(node);
    }
}
