package com.molino.mills.agent;

import com.molino.ai.LRUTranspositionTable;
import com.molino.ai.MinMaxSearch;
import com.molino.ai.SearchNode;
import com.molino.mills.model.GameState;
import com.molino.mills.model.MoveGenerator;

public class MillSearch extends MinMaxSearch<GameState>
{
    private static final int AVG_BRANCHING_FACTOR = 32;
    /**
	 * @uml.property  name="moveGenerator"
	 * @uml.associationEnd  
	 */
    private MoveGenerator moveGenerator;
    
    public MillSearch()
    {
        super(new LRUTranspositionTable<GameState>());
        this.moveGenerator = new MoveGenerator();
    }

    @Override
    protected Iterable<SearchNode<GameState>> generateSuccessors(SearchNode<GameState> node)
    {
        return (Iterable<SearchNode<GameState>>) moveGenerator.generateMoves(new MillSearchNodeMap(AVG_BRANCHING_FACTOR), node.state, false); 
    }       

    @Override
    protected int evaluate(SearchNode<GameState> node)
    {        
        return BoardAnalyser.calculateScore(node.state);
    }
    
    
}