package com.molino.mills.agent;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

import com.molino.ai.SearchNode;
import com.molino.mills.model.GameState;
import com.molino.mills.model.MoveHashMap;
import com.molino.mills.model.MoveMap;

public class MillSearchNodeMap 
    extends HashMap<SearchNode<GameState>, SearchNode<GameState>>
    implements MoveMap, Iterable    
{  
    public MillSearchNodeMap()
    {
        super();
    }

    public MillSearchNodeMap(int initialCapacity)
    {
        super(initialCapacity);
    }

    public MillSearchNodeMap(MoveHashMap moves)
    {
        super(moves.size());
        putAll(moves);
    }

    public void putAll(MoveHashMap moves)
    {
        putAll(moves.values());
    }

    
    public void putAll(Collection<GameState> states)
    {
        for (GameState state : states)
            put(state);        
    }

    public void put(GameState state)
    {
        SearchNode<GameState> node = new SearchNode<GameState>(state);
        
        if ( !containsKey(node) )
            put(node, node);        
    }

    public void add(SearchNode<GameState> node)
    {
        put(node, node);
    }

    public Iterator iterator()
    {
        return keySet().iterator();
    }
}
