package com.molino.mills.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;
import javax.swing.border.BevelBorder;

import com.molino.mills.agent.ComputerPlayer;
import com.molino.mills.model.GameListener;
import com.molino.mills.model.Player;
import com.molino.mills.model.event.GameEvent;
import com.molino.mills.model.event.GameOverEvent;
import com.molino.mills.model.event.InternalErrorEvent;
import com.molino.mills.model.event.MoveEvent;
import com.molino.mills.model.event.MovePromptEvent;
import com.molino.mills.model.event.NewGameEvent;
import com.molino.mills.model.event.TakeBackEvent;
import com.molino.mills.model.move.CaptureMove;
import com.molino.mills.model.move.PassMove;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI Builder, which is free for non-commercial use. If Jigloo is being used commercially (ie, by a corporation, company or business for any purpose whatever) then you should purchase a license for each developer using Jigloo. Please visit www.cloudgarden.com for details. Use of Jigloo implies acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class MulinoPanel extends javax.swing.JPanel
    implements ActionListener, GameListener
{
    private JPanel jPanel1;
    private JLabel movesLbl;
    private JList movesListbox;
    private JButton moveBtn;
    private JTextField moveFld;
    private JLabel moveLabel;
    private JLabel courseLabel;
    private JLabel copyrightLabel;
    private JLabel moveHeadingLbl;
    private JLabel promptLabel2;
    private JScrollPane jScrollPane1;
    private JLabel promptLabel;

    /**
	 * @uml.property  name="gameController"
	 * @uml.associationEnd  
	 */
    private GameController gameController;
    /**
	 * @uml.property  name="boardComponent"
	 * @uml.associationEnd  
	 */
    private BoardComponent boardComponent;
    /**
	 * @uml.property  name="pdl"
	 * @uml.associationEnd  
	 */
    private PieceListener pdl;
    private JPanel statusBarPane;
    private JLabel lastMoveLabel;
    private JPanel jPanel4;
    private JPanel jPanel3;
    /**
	 * @uml.property  name="piecePanel2"
	 * @uml.associationEnd  
	 */
    private PiecePanel piecePanel2;
    private JPanel jPanel2;
    /**
	 * @uml.property  name="piecePanel1"
	 * @uml.associationEnd  
	 */
    private PiecePanel piecePanel1;
    private DefaultListModel movesList;

    /**
     * Auto-generated main method to display this JPanel inside a new JFrame.
     */
    public static void main(String[] args)
    {
        JFrame frame = new JFrame();
        frame.add(new MulinoPanel());
        frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);
    }

    public MulinoPanel()
    {
        gameController = new GameController();
        gameController.setGameListener(this);
        pdl = new PieceListener(this, gameController);
        initGUI();
        gameController.newGame();
    }

    private void initGUI()
    {
        try
        {
            this.setPreferredSize(new java.awt.Dimension(567, 455));

            try
            {
                // Set Look & Feel

                setLayout(null);
                this.setSize(567, 434);
                this.setOpaque(true);
                
                {
                    jPanel1 = new JPanel();
                    GridLayout jPanel1Layout = new GridLayout(1, 1);
                    jPanel1Layout.setHgap(5);
                    jPanel1Layout.setVgap(5);
                    jPanel1Layout.setColumns(1);
                    jPanel1.setLayout(jPanel1Layout);
                    add(jPanel1);
                    jPanel1.setBounds(0, 0, 0, 0);
                }
                {
                    jPanel2 = new JPanel();
                    this.add(jPanel2);
                    FlowLayout jPanel2Layout = new FlowLayout();
                    jPanel2.setBounds(28, 63, 273, 336);
                    jPanel2.setLayout(jPanel2Layout);
                    jPanel2.setOpaque(true);
                    jPanel2.setBackground(new Color(200, 180, 150));
                    jPanel2.setBorder(new BevelBorder(BevelBorder.RAISED));
                    {
                        piecePanel1 = new PiecePanel();
                        piecePanel1.setPieceDragListener(pdl);
                        piecePanel1.setPlayer(0);
                        piecePanel1.setGameController(gameController);
                        piecePanel1.refresh();
                        jPanel2.add(piecePanel1);
                        piecePanel1.setBounds(154, 70, 196, 28);
                        piecePanel1.setPreferredSize(new java.awt.Dimension(208, 32));
                    }
                    {
                        boardComponent = new BoardComponent();
                        pdl.setBoardComponent(boardComponent);
                        jPanel2.add(boardComponent);
                        boardComponent.setShowIndices(true);
                        boardComponent.setShowCoordinates(true);
                        boardComponent.setCoordColor(new Color(250, 250, 150));
                        boardComponent.setIndexColor(new Color(177, 122, 86));
                        boardComponent.setPieceListener(pdl);
                        boardComponent.setGameController(gameController);
                        boardComponent.setBounds(21, 35, 256, 256);
                        boardComponent.setPreferredSize(new java.awt.Dimension(256, 256));
                        boardComponent.initGUI();
                    }
                    {
                        piecePanel2 = new PiecePanel();
                        piecePanel2.setPieceDragListener(pdl);
                        piecePanel2.setPlayer(1);
                        piecePanel2.setGameController(gameController);
                        piecePanel2.refresh();
                        jPanel2.add(piecePanel2);
                        piecePanel2.setBounds(182, 224, 168, 21);
                        piecePanel2.setPreferredSize(new java.awt.Dimension(208, 32));
                    }
                }
                {
                    jPanel4 = new JPanel();
                    BorderLayout jPanel4Layout = new BorderLayout();
                    this.add(jPanel4);
                    jPanel4.setBounds(357, 63, 168, 350);
                    jPanel4.setOpaque(false);
                    jPanel4.setLayout(jPanel4Layout);
                    {
                        movesLbl = new JLabel();
                        jPanel4.add(movesLbl, BorderLayout.NORTH);
                        movesLbl.setText("Historial");
                        movesLbl.setHorizontalAlignment(SwingConstants.LEFT);
                        movesLbl.setPreferredSize(new java.awt.Dimension(156, 14));
                        movesLbl.setHorizontalTextPosition(SwingConstants.LEFT);
                    }
                    {
                        jScrollPane1 = new JScrollPane();
                        jPanel4.add(jScrollPane1, BorderLayout.CENTER);
                        jScrollPane1.setPreferredSize(new java.awt.Dimension(154, 224));
                        jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
                        {
                            movesList = new DefaultListModel();                            
                            movesListbox = new JList();
                            jScrollPane1.setViewportView(movesListbox);
                            movesListbox.setModel(movesList);          
                            movesListbox.setVisibleRowCount(-1);
                            movesListbox.setFont(new java.awt.Font("Courier New",Font.PLAIN,12));
                        }
                    }
                    {
                        jPanel3 = new JPanel();
                        jPanel4.add(jPanel3, BorderLayout.SOUTH);
                        jPanel3.setPreferredSize(new java.awt.Dimension(220, 35));
                        jPanel3.setOpaque(false);
                        {
                            moveLabel = new JLabel();
                            jPanel3.add(moveLabel);
                            moveLabel.setText("Movimiento:");
                            moveLabel.setBounds(28, 287, 77, 14);
                            moveLabel.setPreferredSize(new java.awt.Dimension(34, 14));
                        }
                        {
                            moveFld = new JTextField();
                            moveFld.setActionCommand("Vamos!");
                            jPanel3.add(moveFld);
                            moveFld.setBounds(98, 280, 63, 21);
                            moveFld.setLayout(null);
                            moveFld.setPreferredSize(new java.awt.Dimension(63, 19));
                        }
                        {
                            moveBtn = new JButton();
                            jPanel3.add(moveBtn);
                            moveBtn.setText("Vamos!");
                            moveBtn.setBounds(175, 273, 56, 21);
                        }
                    }
                }
                {
                    promptLabel2 = new JLabel();
                    promptLabel2.setBounds(14, 22, 336, 28);
                    this.add(promptLabel2);
                    promptLabel2.setText("PFC");
                }
                {
                    moveHeadingLbl = new JLabel();
                    this.add(moveHeadingLbl);
                    moveHeadingLbl.setText("Ultimo movimiento:");
                    moveHeadingLbl.setBounds(357, 5, 63, 28);
                }
                {
                    promptLabel = new JLabel();
                    this.add(promptLabel);
                    promptLabel.setText("Bienvenido al molino!");
                    promptLabel.setFont(new java.awt.Font("Arial", 1, 14));
                    promptLabel.setBounds(14, 4, 322, 28);
                }
                {
                    lastMoveLabel = new JLabel();
                    this.add(lastMoveLabel);
                    lastMoveLabel.setBounds(357, 23, 210, 28);
                    lastMoveLabel.setFont(new java.awt.Font("Arial", 1, 14));
                    lastMoveLabel.setText("Ninguno.");
                }
                moveBtn.addActionListener(this);
                moveFld.addActionListener(this);
            }
            catch (Exception e)
            {
                e.printStackTrace();
            }

        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    public void actionPerformed(ActionEvent e)
    {
        if ("Go!".equals(e.getActionCommand()))
        {
            String txt = moveFld.getText().trim();
            gameController.attemptMove(txt);
            moveFld.setText("");            
        }
    }

    public void onGameEvent(GameEvent event)
    {
        if ( event instanceof MovePromptEvent )
            onMovePromptEvent((MovePromptEvent) event);
        else if ( event instanceof MoveEvent )
            onMoveEvent((MoveEvent) event);
        else if ( event instanceof GameOverEvent )
            onGameOverEvent((GameOverEvent) event);            
        else if ( event instanceof InternalErrorEvent)
            onInternalErrorEvent((InternalErrorEvent) event);
        else if ( event instanceof NewGameEvent )
            onNewGameEvent((NewGameEvent) event);
        else if ( event instanceof TakeBackEvent )
            onTakeBackEvent((TakeBackEvent) event);
    }

    /**
     * @param tb
     */
    private void onTakeBackEvent(TakeBackEvent tb)
    {
        if ( tb.isSuccessful() )
        {
            boardComponent.refreshPieceColors();
            piecePanel1.refresh();
            piecePanel2.refresh();            
            int idx = movesList.getSize()-1;
            movesList.removeElementAt(idx--);
            if ( idx < 0 )
            {
                lastMoveLabel.setText("Ninguno.");
            }
            else
            {
                MoveEvent lastMoveEvent = (MoveEvent) movesList.getElementAt(idx);
                lastMoveLabel.setText(lastMoveEvent.getPlayer()+": "+lastMoveEvent.getMove());
            }
        }
        else
        {
            JOptionPane.showMessageDialog(null, "Ningun movimiento para volver atras", "No puede volver atras", JOptionPane.ERROR_MESSAGE);
        }
    }

    /**
     * @param event 
     * 
     */
    private void onNewGameEvent(NewGameEvent event)
    {
        removeAll();
        initGUI();
        gameController.startGame();
    }

    /**
     * @param event
     */
    private void onInternalErrorEvent(InternalErrorEvent event)
    {
        event.getCause().printStackTrace();
        JOptionPane.showMessageDialog(this, event.getCause(), "Error!", JOptionPane.ERROR_MESSAGE);
    }

    /**
     * @param event 
     * 
     */
    private void onGameOverEvent(GameOverEvent event)
    {
        repaint();
        Player winner = gameController.getCurrentGame().getWinner();
        promptLabel.setText("Game over. "+winner+" gana!");
        if ( winner instanceof ComputerPlayer )
            promptLabel2.setText("El molino a terminado");
        else // If human player won
            promptLabel2.setText("Buen trabajo");
        JOptionPane.showMessageDialog(this, winner+" gana!", "Game Over!", JOptionPane.INFORMATION_MESSAGE);
    }

    /**
     * @param event
     */
    private void onMovePromptEvent(MovePromptEvent event)
    {
        promptLabel.setText(event.toString());            
        if ( event.getPlayer() instanceof ComputerPlayer )
            promptLabel2.setText("Ordenador pensando.Espere...");
        else
            promptLabel2.setText(event.getPrompt());
        repaint();
    }


    private void onMoveEvent(MoveEvent moveEvent)
    {       
        boardComponent.refreshPieceColors();
        piecePanel1.refresh();
        piecePanel2.refresh();
        
        int idx = movesList.getSize()-1;
        if ( moveEvent.getMove() instanceof CaptureMove )
        {
            MoveEvent lastMoveEvent = (MoveEvent) movesList.getElementAt(idx);
            lastMoveEvent.appendCaptureMove((CaptureMove) moveEvent.getMove());
            lastMoveLabel.setText(lastMoveEvent.getPlayer()+": "+lastMoveEvent.getMove());
        }
        else if ( !(moveEvent.getMove() instanceof PassMove ) )
        {
            movesList.addElement(moveEvent);
            lastMoveLabel.setText(moveEvent.getPlayer()+": "+moveEvent.getMove());
            idx++;
        }
                
//       movesListbox.scroll
        movesListbox.setSelectedIndex(idx);
        movesListbox.ensureIndexIsVisible(idx);
        repaint();
    }

    /**
	 * @return
	 * @uml.property  name="gameController"
	 */
    public GameController getGameController()
    {
        return gameController;
    }

    /**
	 * @param gameController
	 * @uml.property  name="gameController"
	 */
    public void setGameController(GameController gameController)
    {
        this.gameController = gameController;
    }
}