
package com.molino.mills.model.event;

import com.molino.mills.model.Game;
import com.molino.mills.model.GameState;
import com.molino.mills.model.Player;
import com.molino.mills.model.GameState.Stage;


public class MovePromptEvent extends GameEvent
{
    /**
	 * @uml.property  name="player"
	 * @uml.associationEnd  
	 */
    private Player player;
    /**
	 * @uml.property  name="stage"
	 * @uml.associationEnd  
	 */
    private Stage stage;
    /**
	 * @uml.property  name="awaitingCapture"
	 */
    private int awaitingCapture;
    /**
	 * @uml.property  name="state"
	 * @uml.associationEnd  
	 */
    private GameState state;

    public MovePromptEvent(Game game, GameState state, Player player, Stage stage, int awaitingCapture)
    {
        super(game);
        this.state = state;
        this.player = player;
        this.stage = stage;
        this.awaitingCapture = awaitingCapture;
    }

    public String toString()
    {
        StringBuffer sb = new StringBuffer();
        sb.append(player.toString())
          .append(" mueve.  ");
        
        return sb.toString();
    }
    
    public String getPrompt()
    {
        StringBuffer sb = new StringBuffer();
        if ( awaitingCapture == 1 )
        {

            if ( state.hasOnlyMills(1-player.getPlayerNumber()) )
            {
                sb.append("Captura una pieza del oponente.");
            }
            else
            {
                sb.append("Selecciona cualquier pieza del adversario.");                
            }
        }
        else 
            switch (stage)
            {
            case OPENING:
                sb.append("Pon una pieza en un espacio libre.");               
                break;
            case MIDGAME:
                sb.append("Desliza una pieza en un espacio libre.");               
                break;
            case ENDGAME:
                sb.append("Mueve una pieza a cualquier espacio vacio");               
                break;
            default:
                break;
            }        
        return sb.toString();
  }

    /**
	 * @return
	 * @uml.property  name="awaitingCapture"
	 */
    public int getAwaitingCapture()
    {
        return awaitingCapture;
    }

    /**
	 * @return
	 * @uml.property  name="player"
	 */
    public Player getPlayer()
    {
        return player;
    }

    /**
	 * @return
	 * @uml.property  name="stage"
	 */
    public Stage getStage()
    {
        return stage;
    }
}
