package com.molino.mills.model.pos;


/**
 * @author  Emilio
 */
public class ColRowBoardPosition implements BoardPosition
{
    /**
	 * @uml.property  name="col"
	 */
    private char col;
    /**
	 * @uml.property  name="row"
	 */
    private char row;
    
    public ColRowBoardPosition()
    {
    }

    public ColRowBoardPosition(int position)
    {
        setPosition(position);
    }

    public ColRowBoardPosition(String pos)
    {
        if (pos.length() != 2)
            pos="  ";
        
        setColRowPosition(pos);
    }

    public ColRowBoardPosition(char col, char row)
    {
        setColRowPosition(col, row);
    }
    
    public void setColRowPosition(char col, char row)
    {
        this.col = col;
        this.row = row;
    }
    
    public void setColRowPosition(String pos)
    {
        pos = pos.toUpperCase();
        setColRowPosition(pos.charAt(0), pos.charAt(1));
        
    }
    
    public boolean isValid()
    {
        return col >= 'A' && col <= 'G' && row >= '1' && row <= '7' && toXYBoardPosition().isValid();
    }
    
    public XYBoardPosition toXYBoardPosition()
    {
        return new XYBoardPosition(col-'A'-3, row-'1'-3);
    }

    public int getPosition()
    {
        return toXYBoardPosition().getPosition();
    }

    public void setPosition(int position)
    {
        XYBoardPosition xy = new XYBoardPosition(position);        
        ColRowBoardPosition cr = xy.toColRowBoardPosition();
        this.col = cr.getCol();
        this.row = cr.getRow();        
    }

    public void validate() throws InvalidBoardPositionException
    {
        if ( !isValid() )
            throw new InvalidBoardPositionException(Character.toString(col)+Character.toString(row));
    }

    public void setColRow(char col, char row)
    {
        this.col = col;
        this.row = row;        
    }
    
    /**
	 * @return
	 * @uml.property  name="col"
	 */
    public char getCol()
    {
        return col;
    }

    /**
	 * @param col
	 * @uml.property  name="col"
	 */
    public void setCol(char col)
    {
        this.col = col;
    }

    /**
	 * @return
	 * @uml.property  name="row"
	 */
    public char getRow()
    {
        return row;
    }

    /**
	 * @param row
	 * @uml.property  name="row"
	 */
    public void setRow(char row)
    {
        this.row = row;
    }
   
    public String toString()
    {
        return ""+col+row;
    }
}
